/*
 * ConvRBM_kernel.cuh
 *
 *  Created on: Dec 25, 2009
 *      Author: Alex Krizhevsky (akrizhevsky@gmail.com)
 */

#ifndef CONVRBM_KERNEL_CUH_
#define CONVRBM_KERNEL_CUH_

#include <cutil_inline.h>

#define SPARSE_THREADS_X                16
#define SPARSE_THREADS_Y                16
#define SPARSE_BLOCKS_GLOB              4096
#define SPARSE_THREADS_GLOB             512

#define WEIGHT_NORM_THREADS_X           64

__global__ void kComputeSparseGrads(float* hidProbs, float* hidMeans, float* sparseGrads,
                                    const float sparseCost, const float sparseTarget,
                                    const int width, const int height, const int numConvOutputs);
__global__ void kComputeSparseGradsGlob(float* hidProbs, float* hidMeans, float sparseCost,
                                    float sparseTarget, float* sparseGrads,
                                    const int numCases, const int numHid);
__global__ void kWeightNorm(float* hidVis, float* norms, const int height, const int width, const float thresh);
__global__ void kZeroNegatives(float* g, const int numElements);
__global__ void kComputeBiasGrads(float* hidProbs, float* derivs, const int sumLength, const int height, const int width);
#endif /* CONVRBM_KERNEL_CUH_ */
