/*
 * convCPU.h
 *
 *  Created on: Oct 31, 2009
 *      Author: Alex Krizhevsky (akrizhevsky@gmail.com)
 */

#ifndef CONVCPU_H_
#define CONVCPU_H_

inline float dotCPU(float* img, float* filter, int imgSize, int filterSize, int y, int x);
void convCPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void convColorCPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void convCPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void convColorCPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);

void conv2CPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv2ColorCPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv2CPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv2ColorCPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);

void conv3CPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv3ColorCPU_gfi(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv3CPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);
void conv3ColorCPU_igf(float* imgs, float* filters, float* targets, int imgSize, int filterSize, int numImgsPerGroup, int numFiltersPerGroup, int numGroups);

void rotate180CPU(float* filters, float* targets, int filterSize, int numFilters);
void padZerosCPU(float* images, float* targets, int imgSize, int numImages, int paddingSize);
void subsampleCPU(float* images, float* targets, int imgSize, int factor, int numImgs);
void supersampleCPU(float* images, float* targets, int imgSize, int factor, int numImgs, bool trans);
void gridToMatrixCPU(float* images, float* targets, int imgSize, int factor, int numImgs);
void matrixToGridCPU(float* images, float* targets, int imgSize, int factor, int numImgs);
void sampleMultinomialCPU(float* multi, float* randoms, float* targets, int multinomials, int nomials);
#endif /* CONVCPU_H_ */
